/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */
package org.jvnet.glassfish.comms.clb.proxy.config;


/**
 *
 * @author rampsarathy
 */
public final class LoadBalancerProxyConstants {
    /**
     * Content length header
     */
    public static final String CONTENT_LENGTH = "content-length";

    /**
     * Converged proxy header
     */
    public static final String HTTP_PROXY_HEADER = "felb";

    /**
     * Default read timeout for socket read
     */
    public static final int DEFAULT_READ_TIMEOUT = 1500;

    /**
     * Default HTTP header buffer size.
     */
    public static final int DEFAULT_HTTP_HEADER_BUFFER_SIZE = 48 * 1024;

    /**
     * CRLF.
     */
    public static final String CRLF = "\r\n";

    /**
     * Connection header.
     */
    public static final String HTTP_CONNECTION_HEADER = "connection";
}
